"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageInput = MessageInput;
const React = __importStar(require("react"));
const react_1 = require("react");
const eui_1 = require("@elastic/eui");
const attachments_1 = require("../lib/attachments");
function MessageInput({ loading, onSubmit }) {
    const [query, setQuery] = (0, react_1.useState)('');
    const [attachmentOptions, setAttachmentOptions] = (0, react_1.useState)({ docsOnDashboard: false });
    async function sendMessage() {
        setQuery('');
        setAttachmentOptions({ docsOnDashboard: false });
        onSubmit(query, await (0, attachments_1.getAttachments)(attachmentOptions));
    }
    return (React.createElement("div", { style: { display: 'flex', gap: '4px' } },
        React.createElement(Input, { query: query, attachmentOptions: attachmentOptions, loading: loading, onQueryChange: setQuery, onAttachmentOptionsChange: setAttachmentOptions, onSubmit: sendMessage }),
        React.createElement(eui_1.EuiButton, { fill: true, isLoading: loading, onClick: sendMessage, disabled: !query }, "Send")));
}
function Input({ query, attachmentOptions, loading, onQueryChange, onAttachmentOptionsChange, onSubmit }) {
    const [showAttachmentDropdown, setShowAttachmentDropdown] = (0, react_1.useState)(false);
    return (React.createElement(eui_1.EuiFieldText, { fullWidth: true, disabled: loading, value: query, onChange: e => onQueryChange(e.target.value), onKeyDown: e => e.key === 'Enter' && onSubmit(), append: (React.createElement(eui_1.EuiPopover, { button: React.createElement(eui_1.EuiButtonIcon, { disabled: loading, onClick: () => setShowAttachmentDropdown(true), iconType: "paperClip" }), isOpen: showAttachmentDropdown, closePopover: () => setShowAttachmentDropdown(false) },
            React.createElement(AttachmentOptionsList, { attachmentOptions: attachmentOptions, onChange: onAttachmentOptionsChange }))) }));
}
function AttachmentOptionsList({ attachmentOptions, onChange }) {
    const [numDocsOnDashboard, setNumDocsOnDashboard] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        async function fetchDocCount() {
            let foundDash = false;
            try {
                // @ts-ignore
                const dashboard = await sirenapi.Dashboard.getCurrentDashboard();
                const searchSource = await dashboard.getSearchSource();
                setNumDocsOnDashboard((await searchSource.fetch()).hits.total.value);
                foundDash = true;
            }
            catch (e) {
                console.log('error:', e);
            }
            if (!foundDash) {
                //testing for graph
                // @ts-ignore
                const vis = await sirenapi.Visualization.getCurrentVisualizer().getCurrentGraph();
                const count = vis.nodes?.length;
                if (count) {
                    setNumDocsOnDashboard(count);
                }
            }
        }
        void fetchDocCount();
    }, [setNumDocsOnDashboard]);
    return (React.createElement("div", null,
        React.createElement(eui_1.EuiToolTip, { content: (numDocsOnDashboard && numDocsOnDashboard > 10) ? 'Can not attach more than 10 documents' : undefined },
            React.createElement(eui_1.EuiCheckbox, { id: "dashboard-documents", disabled: !numDocsOnDashboard || numDocsOnDashboard > 10, label: `Include ${numDocsOnDashboard || '...'} documents in current dashboard`, checked: attachmentOptions.docsOnDashboard, onChange: e => onChange({ ...attachmentOptions, docsOnDashboard: e.target.checked }) }))));
}
