"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveAsInsightModal = SaveAsInsightModal;
const React = __importStar(require("react"));
const react_1 = require("react");
const eui_1 = require("@elastic/eui");
const types_1 = require("../../common/types");
const api_1 = require("../lib/api");
const attachments_1 = require("../lib/attachments");
function SaveAsInsightModal({ message, messages, onClose }) {
    const [attachmentIndexToSelectedMap, setAttachmentIndexToSelectedMap] = (0, react_1.useState)({});
    const [customMessage, setCustomMessage] = (0, react_1.useState)('');
    const [saving, setSaving] = (0, react_1.useState)(false);
    if (!message) {
        return null;
    }
    const attachments = [];
    for (const message of messages) {
        if (message.attachments) {
            attachments.push(...message.attachments);
        }
    }
    async function saveInsight() {
        try {
            setSaving(true);
            await api_1.api.post('/saveInsight', {
                text: message.content,
                message: customMessage,
                source: getSourceUrls(attachments.filter((_, i) => attachmentIndexToSelectedMap[i]))
            });
            onClose();
        }
        catch (e) {
            setSaving(false);
            throw e;
        }
    }
    function onCheckboxChange(attachmentIndex) {
        setAttachmentIndexToSelectedMap(attachmentIndexToSelectedMap => ({
            ...attachmentIndexToSelectedMap,
            [attachmentIndex]: !attachmentIndexToSelectedMap[attachmentIndex]
        }));
    }
    return (React.createElement(eui_1.EuiModal, { onClose: onClose },
        React.createElement(eui_1.EuiModalHeader, null,
            React.createElement(eui_1.EuiModalHeaderTitle, null,
                React.createElement("h2", null, "Save as insight"))),
        React.createElement(eui_1.EuiModalBody, null,
            React.createElement(eui_1.EuiFormRow, { label: "Extra information", helpText: "Add some extra context to this insight" },
                React.createElement(eui_1.EuiTextArea, { placeholder: "Optional", value: customMessage, onChange: e => setCustomMessage(e.target.value) })),
            React.createElement(eui_1.EuiFormRow, { label: "Link attachments", helpText: "Choose what attachments (docs, etc.) should be linked as a source for this insight" },
                React.createElement(eui_1.EuiCheckboxGroup, { options: attachments.map((attachment, i) => ({ id: `${i}`, label: (0, attachments_1.getAttachmentLabel)(attachment) })), idToSelectedMap: attachmentIndexToSelectedMap, onChange: onCheckboxChange }))),
        React.createElement(eui_1.EuiModalFooter, null,
            React.createElement(eui_1.EuiButton, { onClick: onClose, disabled: saving }, "Cancel"),
            React.createElement(eui_1.EuiButton, { fill: true, onClick: saveInsight, isLoading: saving }, "Save"))));
}
function getSourceUrls(attachments) {
    const sourceUrls = [];
    for (const attachment of attachments) {
        if ((0, types_1.isDocsAttachment)(attachment)) {
            sourceUrls.push(...attachment.docs.map(doc => doc._id));
        }
    }
    return sourceUrls;
}
