"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSaveInsightRoute = getSaveInsightRoute;
const moment_1 = __importDefault(require("moment/moment"));
// TODO: Supply proper types
function getSaveInsightRoute(server) {
    const callWithRequest = server.plugins.elasticsearch.getCluster('data').callWithRequest;
    const insightsIndex = server.config().get('siren-ai.insightsIndex');
    return {
        path: '/api/ai/saveInsight',
        method: 'POST',
        async handler(req, h) {
            await callWithRequest(req, 'index', {
                index: insightsIndex,
                body: {
                    timestamp: (0, moment_1.default)().toISOString(),
                    text: req.payload.text,
                    investigationId: 'unknown',
                    image: req.payload.image,
                    message: req.payload.message,
                    source: req.payload.source,
                    username: req.auth.credentials?.username
                },
                refresh: true
            });
            return h.response().code(201);
        }
    };
}
