"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createInsightsIndex = createInsightsIndex;
async function createInsightsIndex(server) {
    const insightsIndex = server.config().get('siren-ai.insightsIndex');
    const mapping = {
        index: insightsIndex,
        body: {
            mappings: {
                properties: {
                    timestamp: { type: 'date' },
                    investigationId: { type: 'keyword' },
                    image: { type: 'binary' },
                    text: { type: 'text' },
                    message: { type: 'text' },
                    source: { type: 'keyword' },
                    username: { type: 'keyword' }
                }
            }
        }
    };
    const callWithInternalUser = server.plugins.elasticsearch.getCluster('admin').callWithInternalUser;
    await callWithInternalUser('indices.create', mapping)
        .catch((e) => e.body?.error?.type !== 'resource_already_exists_exception' && Promise.reject(e));
}
